'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.shallowToJson = shallowToJson;

var _lodash = require('lodash.compact');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.omit');

var _lodash4 = _interopRequireDefault(_lodash3);

var _Utils = require('enzyme/build/Utils');

var _Debug = require('enzyme/build/Debug');

var _ShallowTraversal = require('enzyme/build/ShallowTraversal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function nodeToJson(node) {
    if (!node) return node;

    if (typeof node === 'string' || typeof node === 'number') {
        return node;
    }

    var children = (0, _lodash2.default)((0, _ShallowTraversal.childrenOfNode)(node).map(function (n) {
        return nodeToJson(n);
    }));
    var type = (0, _Debug.typeName)(node);
    var props = (0, _lodash4.default)((0, _Utils.propsOfNode)(node), 'children');

    return {
        type: type,
        props: props,
        children: children.length ? children : null,
        $$typeof: Symbol.for('react.test.json')
    };
}

function shallowToJson(wrapper) {
    return nodeToJson(wrapper.node);
}